/*
 * The MIT License (MIT)
 *
 * Copyright © 2021 xrv <xrg@live.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package com.tzld.piaoquan.ad.engine.commons.feign.longvideo.abtest;

import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.ad.engine.commons.feign.CommonResponse;
import com.tzld.piaoquan.ad.engine.commons.feign.longvideo.abtest.fallback.LongVideoFeignFallbackFactory;
import com.tzld.piaoquan.ad.engine.commons.feign.longvideo.abtest.request.AbTestConfigRequest;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 * @author ehlxr
 * @since 2022-10-10 11:42.
 */
@FeignClient(value = "longvideoapi", url = "${longvideo.feign.url:}",
        path = "/longvideoapi",fallbackFactory = LongVideoFeignFallbackFactory.class)
public interface LongVideoFeign {
    /**
     * 获取实验信息
     */
    @RequestMapping(value = "/openapi/abtest/typeValueConfig", method = RequestMethod.POST)
    CommonResponse<JSONObject> getAbTestConfig(@RequestBody AbTestConfigRequest request);
}


