package com.tzld.piaoquan.ad.engine.service.predict.config;

import com.google.gson.Gson;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.*;


@Component
public class AdOutV1OnlineWeightConfig {
    public static Map<String,Double> weightMap=new HashMap<>();

    public final static Double defaultWeight=new Double(0);

    public static Double getWeight(String key){
        return weightMap.getOrDefault(key,defaultWeight);
    }

    //todo weightMap online initialization

    @PostConstruct
    public void initWeightMap(){
        String weightJsonStr="{\n" +
                "  \"bias\": -0.147853,\n" +
                "  \"ctx_apptype#0\": 0.180751,\n" +
                "  \"ctx_apptype#17\": -0.245126,\n" +
                "  \"ctx_apptype#18\": -0.0559548,\n" +
                "  \"ctx_apptype#19\": -0.0976163,\n" +
                "  \"ctx_apptype#21\": -0.246539,\n" +
                "  \"ctx_apptype#22\": -0.230472,\n" +
                "  \"ctx_apptype#3\": -0.304472,\n" +
                "  \"ctx_apptype#4\": -0.00857673,\n" +
                "  \"ctx_apptype#5\": -0.166914,\n" +
                "  \"ctx_apptype#6\": -0.451902,\n" +
                "  \"ctx_hour#00\": -1.33904,\n" +
                "  \"ctx_hour#01\": -1.27071,\n" +
                "  \"ctx_hour#02\": -1.28498,\n" +
                "  \"ctx_hour#03\": -1.19206,\n" +
                "  \"ctx_hour#04\": -1.43452,\n" +
                "  \"ctx_hour#05\": -1.61711,\n" +
                "  \"ctx_hour#06\": -1.71274,\n" +
                "  \"ctx_hour#07\": -1.74905,\n" +
                "  \"ctx_hour#08\": 0.0582405,\n" +
                "  \"ctx_hour#09\": 0.118864,\n" +
                "  \"ctx_hour#10\": 0.14203,\n" +
                "  \"ctx_hour#11\": 0.169456,\n" +
                "  \"ctx_hour#12\": 0.129989,\n" +
                "  \"ctx_hour#13\": 0.102083,\n" +
                "  \"ctx_hour#14\": 0.0894642,\n" +
                "  \"ctx_hour#15\": 0.093456,\n" +
                "  \"ctx_hour#16\": 0.0541803,\n" +
                "  \"ctx_hour#17\": 0.0170209,\n" +
                "  \"ctx_hour#18\": -0.119698,\n" +
                "  \"ctx_hour#19\": -0.172689,\n" +
                "  \"ctx_hour#20\": -0.16682,\n" +
                "  \"ctx_hour#21\": -0.00945801,\n" +
                "  \"ctx_hour#22\": -0.025524,\n" +
                "  \"ctx_hour#23\": -0.0166787,\n" +
                "  \"ctx_week#1\": -0.105368,\n" +
                "  \"ctx_week#2\": -0.100855,\n" +
                "  \"ctx_week#3\": -0.0844838,\n" +
                "  \"ctx_week#4\": -0.127137,\n" +
                "  \"ctx_week#5\": -0.123138,\n" +
                "  \"ctx_week#6\": -0.112104,\n" +
                "  \"ctx_week#7\": -0.0863324\n" +
                "}\n";
        weightMap=new Gson().fromJson(weightJsonStr,HashMap.class);
    }
}
