package com.tzld.piaoquan.ad.engine.service.score.convert;

import com.tzld.piaoquan.ad.engine.commons.score.ScoreParam;
import com.tzld.piaoquan.ad.engine.service.score.dto.AdPlatformCreativeDTO;
import com.tzld.piaoquan.ad.engine.service.score.param.RecommendRequestParam;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdRankItem;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdRequestContext;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;

public class RequestConvert {

    public static ScoreParam requestConvert(RecommendRequestParam request) {
        AdRequestContext context = new AdRequestContext();
        context.setApptype(request.getAppType().toString());
        context.setMachineinfoBrand(request.getMachineInfo().getBrand());
        context.setMachineinfoModel(request.getMachineInfo().getModel());
        context.setMachineinfoSdkversion(request.getMachineInfo().getSdkVersion());
        context.setMachineinfoWchatversion(request.getMachineInfo().getWeChatVersion());

        LocalDateTime date = LocalDateTime.now();
        String hourStr = date.format(DateTimeFormatter.ofPattern("HH"));
        context.setHour(hourStr);
        context.setDay(date.format(DateTimeFormatter.ofPattern("yyyyMMdd")));
        context.setWeek(String.valueOf(date.getDayOfWeek().getValue()));
        context.setRegion(request.getRegion().replace("省", ""));
        context.setCity(request.getCity().replace("市", ""));

        ScoreParam scoreParam = new ScoreParam();
        scoreParam.setAdAbGroup(request.getAdAbGroup());
        scoreParam.setRequestContext(context);
        scoreParam.setVideoId(request.getVideoId());
        scoreParam.setNewExpGroup(request.getNewExpGroup());
        scoreParam.setPqtId(request.getPqtId());
        scoreParam.setMid(request.getMid());
        return scoreParam;
    }

    public static List<AdRankItem> adIdConvertRankItem(List<AdPlatformCreativeDTO> creativeDTOList, RecommendRequestParam request) {
        List<AdRankItem> adRankItems = new ArrayList<>(creativeDTOList.size());
        for (AdPlatformCreativeDTO dto : creativeDTOList) {
            AdRankItem adRankItem = new AdRankItem();
            adRankItem.setAdId(dto.getCreativeId());
            adRankItem.setCreativeCode(dto.getCreativeCode());
            adRankItem.setAdVerId(dto.getAdVerId());
            adRankItem.setVideoId(request.getVideoId());
            adRankItem.setWeight(dto.getWeight());
        }
        return adRankItems;
    }
}
